package com.gic.spark.filter;

import com.gic.spark.datasource.entity.DataSourceHive;
import com.gic.spark.entity.bean.TrdVirtualOrderBean;
import com.gic.spark.entity.request.AbstractFilterRequest;
import com.gic.spark.entity.request.AbstractFilterRequestTime;
import com.gic.spark.util.ConstantUtil;
import com.gic.spark.util.DateUtil;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.Optional;
import scala.Tuple2;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;


/**
 * @description:
 * 消费记录
 * @author: wangxk
 * @date: 2020/8/3
 */
public abstract class AbstractTagConsumRecordFilter implements BaseTagFilter {

     DataSourceHive dataSourceHiveOrder = new DataSourceHive(ConstantUtil.DWD_GIC_TRD_VIRTUAL_WDORDER_D);
    DataSourceHive dataSourceHiveOrderItem = new DataSourceHive(ConstantUtil.DWD_GIC_TRD_VIRTUAL_ORDER_ITEM_D);

    protected static JavaRDD<TrdVirtualOrderBean> statisticsTypeHandle(JavaRDD<Tuple2<TrdVirtualOrderBean,Optional<Iterable<String>>>>orderRdd, AbstractFilterRequest request){
        JavaRDD<TrdVirtualOrderBean>consumeRecordRDD=orderRdd.mapPartitions(data->{
                                                        List<TrdVirtualOrderBean> result=new ArrayList();
                                                        while (data.hasNext()){
                                                            Tuple2<TrdVirtualOrderBean,Optional<Iterable<String>>> tp2=data.next();
                                                            TrdVirtualOrderBean consumeRecordBean=tp2._1();
                                                                switch (request.getStatisticsType()){
                                                                    case COMMODITYBRAND:
                                                                        if(tp2._2().isPresent()){
                                                                            for(String ent_brand_id:tp2._2().get()){
                                                                                if(request.getStatisticsValList().contains(ent_brand_id)){
                                                                                    result.add(consumeRecordBean);
                                                                                    break;
                                                                                }
                                                                            }
                                                                        }

                                                                        break;
                                                                    case CHANNEL:
                                                                        if(request.getStatisticsValList().contains(String.valueOf(consumeRecordBean.getStore_info_id()))){
                                                                            result.add(consumeRecordBean);
                                                                        }
                                                                        break;
                                                                    case MCUINFO:
                                                                        if(request.getStatisticsValList().contains(String.valueOf(consumeRecordBean.getArea_id()))){
                                                                            result.add(consumeRecordBean);
                                                                        }
                                                                        break;
                                                                    default:break;
                                                                }
                                                            }
                                                        return result.iterator();
                                                    });
        return consumeRecordRDD;
    }

    protected static boolean checkTime(AbstractFilterRequestTime request,long consumeTime){
        Boolean result=false;
        switch (request.getTimeRangeType()){
            case FIXATION:
                if(consumeTime>=request.getBeginTime().getTime()
                        &&consumeTime<=request.getEndTime().getTime())
                    result=true;
                break;
            case LATELY:
                switch (request.getYearMonthDayType()){
                    case DAY:
                        if(consumeTime> DateUtil.addNumForDay(new Date(),-request.getTimeNum()).getTime()){
                            result=true;
                        }
                        break;
                    case MONTH:
                        if(consumeTime>DateUtil.addNumForMonth(new Date(),-request.getTimeNum()).getTime()){
                            result=true;
                        }
                        break;
                    case YEAR:
                        if(consumeTime>DateUtil.addNumForYear(new Date(),-request.getTimeNum()).getTime()){
                            result=true;
                        }
                        break;
                    default:break;
                }
                break;
            default:break;
        }
        return  result;
    }
}
